#include <string.h>
#include <stdio.h>
#define MAX 4
#define MIN 2

//typedef int Key_Type;
typedef struct{
		char AdSoyad[30];
		int  index;
	      }Key_Type;

typedef struct node_tag {
			  int count;
			  Key_Type key[MAX+1];
			  struct node_tag *branch[MAX+1];
			}Node_Type;

Node_Type *Search(Key_Type target,Node_Type *root,int *targetpos)
{
  if (root==NULL)
    return NULL;
  else if (SearchNode(target,root,targetpos))
    return root;
  else
    return Search(target,root->branch[*targetpos],targetpos);
}

int SearchKey(Node_Type *root,char *AraAdSoyad)
{
  Key_Type SearchKey;
  Node_Type *p;
  int k;
  strcpy(SearchKey.AdSoyad,AraAdSoyad);
  p=Search(SearchKey,root,&k);
  if ( p != NULL)
    return p->key[k].index;
  else
    return -1;
}

int LT(Key_Type p1,Key_Type p2)
{
  if ((strcmp(p1.AdSoyad,p2.AdSoyad)) < 0)
    return 1;
  else
    return 0;
}


int EQ(Key_Type p1,Key_Type p2)
{
  if ((strcmp(p1.AdSoyad,p2.AdSoyad)) == 0)
    return 1;
  else
    return 0;
}

int FindSmallest(Node_Type *p)
{
  int small=-1;
  while (p!=NULL)
    {
      small=p->key[1].index;
      p=p->branch[0];
    }
  return small;
}

// Finds the first higher key after s
int FindNext(Node_Type *p,char *s)
{
  int next=-1,k,k2;
  Key_Type key;

  strcpy(key.AdSoyad,s);
  while (p!=NULL)
    {
      if (SearchNode(key,p,&k))
	{
	  // If it is in this node
	  // If it is not the last key
	  if  (k<p->count)
	     {
	       if ( p->branch[k] == NULL)
		 return p->key[k+1].index;
	       else
		 return p->branch[k]->key[1].index;
	     }
	  else
	     {
	       if ( p->branch[k] == NULL)
		 return -1;
	       else
		 return p->branch[k]->key[1].index;
	     }
	}
      else if (SearchNode(key,p->branch[k],&k2))
	  {
	    if (k2==p->branch[k]->count)
	      {
		if (k==p->count)
		  return -1;
		else
		  return p->key[k+1].index;
	      }
	    else
	      p=p->branch[k];
	  }
      else
	p=p->branch[k];
    }
  return -1;
}


int SearchNode(Key_Type target,Node_Type *p,int *k)
{
  if ( LT(target,p->key[1]) )
    {
      *k=0;
      return 0;  //return FALSE
    }
  else
    {
      *k=p->count;
      while (LT(target,p->key[*k])&&*k>1)
	 (*k)--;
      return EQ(target,p->key[*k]);
    }

}



Node_Type *Insert(Key_Type newkey,Node_Type *root)
{
   Key_Type x;
   Node_Type *xr,*p;
   int pushup;
   pushup=PushDown(newkey,root,&x,&xr);
   if (pushup)
     {
       p=(Node_Type *) malloc(sizeof(Node_Type));
       p->count=1;
       p->key[1]=x;
       p->branch[0]=root;
       p->branch[1]=xr;
       return p;
     }
   return root;
}


void PushIn(Key_Type x,Node_Type *xr,Node_Type *p,int k)
{
  int i;
  for (i=p->count;i>k;i--)
    {
      p->key[i+1]=p->key[i];
      p->branch[i+1]=p->branch[i];
    }
  p->key[k+1]=x;
  p->branch[k+1]=xr;
  p->count++;

}



void Split(Key_Type x,Node_Type *xr,Node_Type *p,int k,Key_Type *y,
	   Node_Type **yr)
{
   int i;
   int median;
   Node_Type *l;
   if (k<=MIN)
     median=MIN;
   else
     median=MIN+1;
   *yr=(Node_Type *) malloc(sizeof(Node_Type));
   for (i=median+1;i<=MAX;i++)
     {
       (*yr)->key[i-median]=p->key[i];
       (*yr)->branch[i-median]=p->branch[i];
     }
   (*yr)->count=MAX-median;
   p->count=median;
   if (k<=MIN)
      PushIn(x,xr,p,k);
   else
      PushIn(x,xr,*yr,k-median);
   *y=p->key[p->count];
   (*yr)->branch[0]=p->branch[p->count];
   p->count--;
}


int PushDown(Key_Type newkey,Node_Type *p,Key_Type *x,Node_Type **xr)
{
  int k;
  if (p==NULL)
    {
      *x=newkey;
      *xr=NULL;
      return 1;
    }
  else
    {
      if (SearchNode(newkey,p,&k))        ;
	//ERROR("INSERTING DUPLICATE KEY")
      if (PushDown(newkey,p->branch[k],x,xr))
	if (p->count<MAX)
	  {
	    PushIn(*x,*xr,p,k);
	    return 0;
	  }
	else
	  {
	    Split(*x,*xr,p,k,x,xr);
	    return 1;
	  }
      return 0;
    }
}


void Remove(Node_Type *p,int k)
{
  int i;
  for (i=k+1;i<=p->count;i++)
    {
      p->key[i-1]=p->key[i];
      p->branch[i-1]=p->branch[i];
    }
  p->count--;
}

void Successor(Node_Type *p,int k)
{
  Node_Type *q;
  for (q=p->branch[k];q->branch[0];q=q->branch[0]);
  p->key[k]=q->key[1];
}


void MoveRight(Node_Type *p,int k)
{
  int c;
  Node_Type *t;
  t=p->branch[k];
  for (c=t->count;c>0;c--)
    {
      t->key[c+1]=t->key[c];
      t->branch[c+1]=t->branch[c];
    }
  t->branch[1]=t->branch[0];
  t->count++;
  t->key[1]=p->key[k];
  t=p->branch[k-1];
  p->key[k]=t->key[t->count];
  p->branch[k]->branch[0]=t->branch[t->count];
  t->count--;
}

void MoveLeft(Node_Type *p,int k)
{
  int c;
  Node_Type *t;
  t=p->branch[k-1];

  t->count++;
  t->key[t->count]=p->key[k];
  t->branch[t->count]=p->branch[k]->branch[0];

  t=p->branch[k];
  p->key[k]=t->key[1];
  t->branch[0]=t->branch[1];
  t->count--;
  for (c=1;c<=t->count;c++)
    {
      t->key[c]=t->key[c+1];
      t->branch[c]=t->branch[c+1];
    }
}


void Combine(Node_Type *p,int k)
{
  int c;
  Node_Type *q,*l;
  q=p->branch[k];
  l=p->branch[k-1];
  l->count++;
  l->key[l->count]=p->key[k];
  l->branch[l->count]=q->branch[0];
  for (c=1;c<=q->count;c++)
    {
      l->count++;
      l->key[l->count]=q->key[c];
      l->branch[l->count]=q->branch[c];
    }
  for (c=k;c<p->count;c++)
    {
      p->key[c]=p->key[c+1];
      p->branch[c]=p->branch[c+1];
    }
  p->count--;
  free(q);
}

void Restore(Node_Type *p,int k)
{
  if (k==0)
    if (p->branch[1]->count>MIN)
      MoveLeft(p,1);
    else
      Combine(p,1);
  else if (k==p->count)
    if (p->branch[k-1]->count>MIN)
      MoveRight(p,k);
    else
      Combine(p,k);
  else if (p->branch[k-1]->count>MIN)
    MoveRight(p,k);
  else if (p->branch[k+1]->count>MIN)
    MoveLeft(p,k+1);
  else
    Combine(p,k);
}





int RecDelete(Key_Type target,Node_Type *p)
{
  int k,found;
  if (p==NULL)
    return 0;
  else
    {
      if (found=SearchNode(target,p,&k))
	if (p->branch[k-1])
	  {
	    Successor(p,k);
	    if (!(found=RecDelete(p->key[k],p->branch[k])));
	      //ERROR KYEEY NOT FOUND
	  }
	else
	  Remove(p,k);
      else
	found=RecDelete(target,p->branch[k]);
      if (p->branch[k]!=NULL)
	if (p->branch[k]->count<MIN)
	   Restore(p,k);
      return found;
    }

}


Node_Type *Delete(Key_Type target,Node_Type *root)
{
  Node_Type *p;
  if (!RecDelete(target,root));
       //ERROR(Target was not in the btree)
  else if (root->count==0)
     {
       p=root;
       root=root->branch[0];
       free(p);
     }
  return root;
}




void CreateTree(Node_Type **root)
{
  *root=NULL;
}

void InsertKey(Key_Type key,Node_Type **root)
{

  *root=Insert(key,*root);
}

void DeleteKey(Key_Type key,Node_Type **root)
{
  *root=Delete(key,*root);
}

void DestroyTree(Node_Type **root)
{
  int i;
  if ((*root)!=NULL)
    {
      for (i=0;i<=(*root)->count;i++)
	DestroyTree(&((*root)->branch[i]));
      free((*root));
      (*root)=NULL;
    }
  return;
}
