#include <stdio.h>
#include <btree.h>
#include <errno.h>
//#define HASTADOSYASI   "hasta.dat"   //Hasta dosyas ismi
//#define MUAYENEDOSYASI "muayene.dat" //Muayene dosyas ismi
#define HASTAYEDEK     "hasyedek.dat"   //Hasta dosyas ismi
#define MUAYENEYEDEK   "muayedek.dat" //Muayene dosyas ismi


typedef struct {
		 char isaret;
		 char ad_soyad[30],dogum_yer[12],dogum_tar[11];
		 char adres[40],sehir[12],tel[12];
		 int tedavileri; // Muayene dosyasndaki ilk tedavi kayd indexi
	       } hasta_kaydi;
typedef struct {
		 char isaret;
		 char muayene_tar[11],sikayet[30],tani[30];
		 char tedavi[30],ilac[30],not[30];
		 int  onceki,sonraki;
	       } muayene_kaydi;

typedef struct {
		 hasta_kaydi hasta;
		 muayene_kaydi muayene;
	       } tedavi_kaydi;


FILE *hasta_dos,*muayene_dos;
Node_Type *agac;
extern char HASTADOSYASI[80];
extern char MUAYENEDOSYASI[80];

//
hasta_kaydi HastaKaydiGetir(int index)
{
  int kayitpoz;
  hasta_kaydi gecici;
  hasta_dos=fopen(HASTADOSYASI,"r");
  kayitpoz=(index-1)*sizeof(hasta_kaydi);  // Kaydn pozisyonunu bul
  fseek(hasta_dos,kayitpoz,SEEK_SET);
  fread(&gecici,sizeof(hasta_kaydi),1,hasta_dos);
  fclose(hasta_dos);
  return gecici;
}

//
muayene_kaydi MuayeneKaydiGetir(int index)
{
  int kayitpoz;
  muayene_kaydi gecici;
  muayene_dos=fopen(MUAYENEDOSYASI,"r");
  kayitpoz=(index-1)*sizeof(muayene_kaydi);  // Kaydn pozisyonunu bul
  fseek(muayene_dos,kayitpoz,SEEK_SET);
  fread(&gecici,sizeof(muayene_kaydi),1,muayene_dos);
  fclose(muayene_dos);
  return gecici;
}

//
// Eger index -1 ise dosya sonuna kayt yaplr.
int HastaKaydiYaz(int index,hasta_kaydi hasta)
{
  int kayitpoz;
  int son_index;
  hasta_kaydi gecici;
  hasta.isaret='*';
  hasta_dos=fopen(HASTADOSYASI,"r+");
  if (index > 0)  // Eger belirli bir indexe eklenecekse
    {
       // Kaydn index numarasna gore kayda eris
       kayitpoz=(index-1)*sizeof(hasta_kaydi);  // Kaydn pozisyonunu bul
       fseek(hasta_dos,kayitpoz,SEEK_SET);
       // Kayd oku
       fread(&gecici,sizeof(hasta_kaydi),1,hasta_dos);
       if (gecici.isaret!='*')  // Eger gecerli bir kayt degilse
	{
	  // Tekrar ayn yere eris
	  fseek(hasta_dos,kayitpoz,SEEK_SET);
	  // Yeni kayd buaraya ekle
	  fwrite(&hasta,sizeof(hasta_kaydi),1,hasta_dos);
	  fclose(hasta_dos);
	  return index;             // Ekledigi yerin indexini dondur
	}
    }
   else if (index==-1)  // Eger dosya sonuna eklencekse
    {
      // Dosya sonuna ekleme icin dosya sonua eris
      fseek(hasta_dos,0,SEEK_END);
      son_index=(int) ( ftell(hasta_dos) / sizeof(hasta_kaydi)) + 1;
      fwrite(&hasta,sizeof(hasta_kaydi),1,hasta_dos);
      fclose(hasta_dos);
      return son_index;
    }
  fclose(hasta_dos);
  return 0;
}

//
// Index -1 ise dosya sonuna kayt yaplr.
int MuayeneKaydiYaz(int index,muayene_kaydi muayene)
{
  int kayitpoz;
  int son_index;
  muayene_kaydi gecici;
  muayene_dos=fopen(MUAYENEDOSYASI,"r+");
  muayene.isaret='*';
  if (index > 0)
    {
       // Kaydn index numarasna gore kayda eris
       kayitpoz=(index-1)*sizeof(muayene_kaydi);  // Kaydn pozisyonunu bul
       fseek(muayene_dos,kayitpoz,SEEK_SET);
       // Kayd oku
       fread(&gecici,sizeof(muayene_kaydi),1,muayene_dos);
       if (gecici.isaret!='*')   // Eger gecerli bir kayt degilse
	{
	  // Tekrar ayn yere eris
	  fseek(muayene_dos,kayitpoz,SEEK_SET);
	  // Yeni kayd buaraya ekle
	  fwrite(&muayene,sizeof(muayene_kaydi),1,muayene_dos);
	  fclose(muayene_dos);
	  return index;
	}
    }
   else if (index==-1)
    {
      // Dosya sonuna ekleme
      fseek(muayene_dos,0,SEEK_END);   // Eger dosya sonuna eklencekse
      son_index=(int) ( ftell(muayene_dos) / sizeof(muayene_kaydi)) + 1;
      fwrite(&muayene,sizeof(muayene_kaydi),1,muayene_dos);
      fclose(hasta_dos);
      return son_index;
    }
  fclose(muayene_dos);
  return 0;
}


//
int HastaKaydiDuzelt(int index,hasta_kaydi hasta)
{
  int kayitpoz;
  int son_index;
  hasta_kaydi gecici;
  hasta_dos=fopen(HASTADOSYASI,"r+");
  if (index > 0)
    {
       // Hasta kaydnn indexini hesapla ve buaradan kayd oku
       kayitpoz=(index-1)*sizeof(hasta_kaydi);  // Kaydn pozisyonunu bul
       fseek(hasta_dos,kayitpoz,SEEK_SET);
       fread(&gecici,sizeof(hasta_kaydi),1,hasta_dos);
       if (gecici.isaret=='*')  // Eger gecerli bir kayt ise
	{
	  // Tedaviler bilgisini kaybetmeden guncel kayda aktar
	  //hasta.tedavileri=gecici.tedavileri;
	  // Guncel kayd eskisinin bulundugu yere yaz
	  fseek(hasta_dos,kayitpoz,SEEK_SET);
	  fwrite(&hasta,sizeof(hasta_kaydi),1,hasta_dos);
	  fclose(hasta_dos);
	  return 1;
	}
    }
  fclose(hasta_dos);
  return 0;
}


//
int MuayeneKaydiDuzelt(int index,muayene_kaydi muayene)
{
  int kayitpoz;
  int son_index;
  muayene_kaydi gecici;
  muayene_dos=fopen(MUAYENEDOSYASI,"r+");
  if (index > 0)
    {
       // Muayene kaydnn indexini hesapla ve buaradan kayd oku
       kayitpoz=(index-1)*sizeof(muayene_kaydi);  // Kaydn pozisyonunu bul
       fseek(muayene_dos,kayitpoz,SEEK_SET);
       fread(&gecici,sizeof(muayene_kaydi),1,muayene_dos);
       if (gecici.isaret=='*')
	{
	  fseek(muayene_dos,kayitpoz,SEEK_SET);
	  fwrite(&muayene,sizeof(muayene_kaydi),1,muayene_dos);
	  fclose(muayene_dos);
	  return 1;
	}
    }
  fclose(muayene_dos);
  return 0;
}


//
int HastaKaydiSil(char *ad_soyad)
{
  hasta_kaydi   gecici;
  muayene_kaydi gecici2;
  int hasta_index,muayene_index;
  Key_Type key;

  hasta_index=SearchKey(agac,ad_soyad);
  // Eger boyle bir hasta arama agacnda bulunumussa
  if (hasta_index!=-1)
    {
      // Hasta kaydna erisim
      gecici=HastaKaydiGetir(hasta_index);
      // lk muayene kaydna erisim
      if (gecici.tedavileri!=0)
	{
	   muayene_index=gecici.tedavileri;
	   gecici2=MuayeneKaydiGetir(gecici.tedavileri);
	   while (gecici2.sonraki!=0)
	       {
		 // Her bir muayene kaydn gecersiz yap (sil)
		 gecici2.isaret=' ';
		 MuayeneKaydiDuzelt(muayene_index,gecici2);
		 muayene_index=gecici2.sonraki;
		 gecici2=MuayeneKaydiGetir(muayene_index);
	       }
	 }
      // Hasta kaydnn gecersiz yap (sil)
      gecici.isaret=' ';
      HastaKaydiDuzelt(hasta_index,gecici);
      strcpy(key.AdSoyad,gecici.ad_soyad);
      DeleteKey(key,&agac);
      return 1;
    }
  return 0;
}

//
int MuayeneKaydiSil(char *ad_soyad,char *tarih)
{
  hasta_kaydi   gecici;
  muayene_kaydi gecici2;
  int           onceki, sonraki;
  int hasta_index,muayene_index;

  hasta_index=SearchKey(agac,ad_soyad);
  // Eger boyle bir hasta arama agacnda bulunumussa
  if (hasta_index!=-1)
    {
      // Hasta kaydna erisim
      gecici=HastaKaydiGetir(hasta_index);
      // lk muayene kaydna erisim
      muayene_index=gecici.tedavileri;
      gecici2=MuayeneKaydiGetir(gecici.tedavileri);
      while (gecici2.sonraki!=0)
	    // O tarihteki muayene kayd ise ve bu muayene kayd o hastann
	    // tek muayene kayd deilse sil.
	    if (    (gecici2.muayene_tar==tarih)
		 && (gecici2.sonraki!=gecici2.onceki) )
	      {
		// O tarihteki muayene kaydn gecersiz yap (sil)
		gecici2.isaret=' ';
		MuayeneKaydiDuzelt(muayene_index,gecici2);
		// Bundan onceki ve bundan sonraki muayeneleri birbirine bagla
		onceki=gecici2.onceki;
		sonraki=gecici2.sonraki;
		gecici2=MuayeneKaydiGetir(onceki);
		gecici2.sonraki=sonraki;
		MuayeneKaydiDuzelt(onceki,gecici2);
		gecici2=MuayeneKaydiGetir(sonraki);
		gecici2.onceki=onceki;
		MuayeneKaydiDuzelt(sonraki,gecici2);
	      }
      return 1;
    }
  return 0;
}

//
int TedaviKaydiEkle(tedavi_kaydi kayit)
{
  int hasta_index,muayene_index,son_index;
  hasta_kaydi   hasta;
  muayene_kaydi muayene;
  Key_Type      key;

  kayit.muayene.sonraki=0;
  // Hasta dosyasnda bu isimde bir hasta var m?
  hasta_index=SearchKey(agac,kayit.hasta.ad_soyad);
  if (hasta_index==-1)   //Eger yoksa yeni bir hasta kaydi olustur
    {
      // Bu hastann ilk muayene kayd
      kayit.muayene.onceki=0;
      // Ege muayene kaydi varsa muayene kaydn dosyann sonuna (-1) yaz.
      if (kayit.muayene.muayene_tar[0]!='\0')
	{
	  muayene_index=MuayeneKaydiYaz(-1,kayit.muayene);
	  kayit.hasta.tedavileri = muayene_index;
	}
      else
	kayit.hasta.tedavileri = 0;
      // Hasta kaydn dosyann sonuna (-1) yaz.
      hasta_index=HastaKaydiYaz(-1,kayit.hasta);
      // Hastann ismini ve kaydnn indexini arama agacna kaydet
      strcpy(key.AdSoyad,kayit.hasta.ad_soyad);
      key.index=hasta_index;
      InsertKey(key,&agac);
    }
  else   // Eger hasta kayd zaten varsa, muayeneler listesine yeni eleman ekle
    {
      hasta=HastaKaydiGetir(hasta_index);
      // Yeni kayd son_index'e kaydet.
      son_index=MuayeneKaydiYaz(-1,kayit.muayene);
      // Hastann ilk muayene kaydn bul
      muayene_index=hasta.tedavileri;
      if (muayene_index!=0)
	{
	  muayene=MuayeneKaydiGetir(muayene_index);
	  // Bu hastann muayenelerini takip ederek son muayenesini bul.
	  while (muayene.sonraki!=0)
	      {
		muayene_index=muayene.sonraki;
		muayene=MuayeneKaydiGetir(muayene.sonraki);
	      }
	}
      else
	{
	  hasta.tedavileri = son_index;
	  HastaKaydiDuzelt(hasta_index,hasta);
	}
      // Yeni kaydn onceki muayene indexi bu bulunan son muayene kayd.
      kayit.muayene.onceki=muayene_index;
      // Eski son muayenenin sonraki isaretcisi bu yeni muayene
      muayene.sonraki=son_index;
      // Duzeltilmis halini sakla.
      MuayeneKaydiDuzelt(muayene_index,muayene);
    }
  return 0;
}


//
int TedaviKaydiDuzelt(tedavi_kaydi eski,tedavi_kaydi guncel)
{
  int hasta_index,muayene_index;
  hasta_kaydi   hasta;
  muayene_kaydi muayene;
  Key_Type      key;

  hasta_index=SearchKey(agac,eski.hasta.ad_soyad);
  // Eger kayt bulunduysa
  if (hasta_index!=-1)
    {
      hasta = HastaKaydiGetir(hasta_index);
      guncel.hasta.tedavileri=hasta.tedavileri;
      // Eger degisen hastanin ismi ise bu degisikligi agacta da yap.
      if (strcmp(guncel.hasta.ad_soyad,eski.hasta.ad_soyad)!=0)
	{
	  // Eski anahtari agactan sil
	  strcpy(key.AdSoyad,eski.hasta.ad_soyad);
	  DeleteKey(key,&agac);
	  // Yeni anahtari agaca ekle.
	  strcpy(key.AdSoyad,guncel.hasta.ad_soyad);
	  key.index=hasta_index;
	  InsertKey(key,&agac);
	}
      HastaKaydiDuzelt(hasta_index,guncel.hasta);
      // lgili muayene kaydn duzelt
      // Hastann ilk muayene kaydn bul
      if ((muayene_index=hasta.tedavileri)!=0)
	{
	   muayene=MuayeneKaydiGetir(muayene_index);
	   // Bu hastann muayenelerini takip ederek ilgili muayenesini bul.
	   while (muayene.sonraki!=0)
	       {
		 //Eger ilgili muayene bulunduysa bunu guncel.muayene ile degistir.
		 if (strcmp(muayene.muayene_tar,eski.muayene.muayene_tar)==0)
		   {
		     guncel.muayene.onceki = muayene.onceki;
		     guncel.muayene.sonraki= muayene.sonraki;
		     MuayeneKaydiDuzelt(muayene_index,guncel.muayene);
		   }
		 muayene_index=muayene.sonraki;
		 muayene=MuayeneKaydiGetir(muayene.sonraki);
	       }
	   if (strcmp(muayene.muayene_tar,eski.muayene.muayene_tar)==0)
	      {
		guncel.muayene.onceki = muayene.onceki;
		guncel.muayene.sonraki= muayene.sonraki;
		MuayeneKaydiDuzelt(muayene_index,guncel.muayene);
	      }
	}
      return 1;
    }
  return 0;
}



//
// Hasta dosyasn tarayarak gecerli kaytlar bulundugu bir arama agac olusturur.
Node_Type *HastaAgaciOlustur(Node_Type *agac)
{
  int kayitpoz,index;
  int son_index;
  hasta_kaydi gecici;
  Key_Type    key;

  fcloseall();
  hasta_dos=fopen(HASTADOSYASI,"r+");
  // Son indeks numarasn bul
  fseek(hasta_dos,0,SEEK_END);
  son_index=(int) ( ftell(hasta_dos) / sizeof(hasta_kaydi)) + 1;
  for (index=1;index<son_index;index++)
    {
      gecici=HastaKaydiGetir(index);
      // Eger burada gecerli bir kayt varsa bunu agaca sakla
      if (gecici.isaret=='*')
	{
	  strcpy(key.AdSoyad,gecici.ad_soyad);
	  key.index=index;
	  InsertKey(key,&agac);
	}
    }
  fclose(hasta_dos);
  return agac;
}



//
void DosyalariYedekle()
{
  int kayitpoz,index;
  int son_index;
  hasta_kaydi gecici;
  muayene_kaydi gecici2;
  FILE *hasta_yedek_dos,*muayene_yedek_dos;

  fcloseall();
  // Hasta dosyasnn yedeklenmesi
  hasta_dos=fopen(HASTADOSYASI,"r+");
  hasta_yedek_dos=fopen(HASTAYEDEK,"w");
  fseek(hasta_dos,0,SEEK_SET);
  while (!(feof(hasta_dos)))
    {
      fread(&gecici,sizeof(hasta_kaydi),1,hasta_dos);
      if ((gecici.isaret=='*') && (!(feof(hasta_dos))) )
	  fwrite(&gecici,sizeof(gecici),1,hasta_yedek_dos);
    }
  fclose(hasta_dos);
  fclose(hasta_yedek_dos);
  // Muayene dosyasnn yedeklenmesi
  muayene_dos=fopen(HASTADOSYASI,"r+");
  muayene_yedek_dos=fopen(HASTAYEDEK,"w");
  fseek(muayene_dos,0,SEEK_SET);
  while (!(feof(muayene_dos)))
    {
      fread(&gecici2,sizeof(muayene_kaydi),1,muayene_dos);
      if ((gecici.isaret=='*') && (!(feof(muayene_dos))) )
	  fwrite(&gecici2,sizeof(gecici2),1,muayene_yedek_dos);
    }
  fclose(muayene_dos);
  fclose(muayene_yedek_dos);
}