#include <stdio.h>
#include <dosya.h>

// Islem tipleri
#define EKLE        0
#define DUZELT      1
#define HASTASIL    2
#define MUAYENESIL  3
#define MAXISLEM    10


#define ISLEMDOSYASI "islemdos.dat"

typedef struct {
		 short islem_tipi;
		 tedavi_kaydi eski;
		 tedavi_kaydi guncel;
	       }islem_kaydi;

FILE *islem_dos;

//
void IslemDosyasiCalistir(void)
{
  islem_kaydi islem;
  islem_dos=fopen(ISLEMDOSYASI,"r");
  while (!feof(islem_dos))
    {
      fread(&islem,sizeof(islem_kaydi),1,islem_dos);
      if (!feof(islem_dos))
	switch (islem.islem_tipi)
	  {
	    case EKLE      : TedaviKaydiEkle(islem.guncel);break;
	    case DUZELT    : TedaviKaydiDuzelt(islem.eski,islem.guncel);break;
	    case HASTASIL  : HastaKaydiSil(islem.eski.hasta.ad_soyad);break;
	    case MUAYENESIL: MuayeneKaydiSil(islem.eski.hasta.ad_soyad,
					     islem.eski.muayene.muayene_tar);
					     break;
	  }
    }
  // Islem dosyasn sil
  remove(ISLEMDOSYASI);
}


//
int IslemKaydiEkle(short islem_tipi,tedavi_kaydi eski,tedavi_kaydi guncel)
{
  islem_kaydi islem;
  int 	      errno,kayit_sayisi;
  // Islem kaydn olustur
  islem.islem_tipi=islem_tipi;
  islem.eski=eski;
  islem.guncel=guncel;
  // Islem dosyasn okuma modunda ac
  islem_dos=fopen(ISLEMDOSYASI,"a");
  // Islemi sonuna kaydet
  fwrite(&islem,sizeof(islem_kaydi),1,islem_dos);
  fclose(islem_dos);  // Islem dosyas kapatld
  islem_dos=fopen(ISLEMDOSYASI,"r+");
  // Dosyann sonuna git
  fseek(islem_dos,0,SEEK_END);
  // Kayit sayisini hesapla
  kayit_sayisi=(int) ((ftell(islem_dos))/sizeof(islem_kaydi));
  fclose(islem_dos);
  // Eger maximum islem kaydi sayisina ulasilmis ise islemleri yap.
  if (kayit_sayisi>=MAXISLEM)
    {
      IslemDosyasiCalistir();
      return 1;    //Islemler yapldg icin 1 degeri dondu
    }
  return 0;  // Islemler yaplmadg icin 0 degeri dondu.
}
